<id>
Board Rules for YaBB 2.5
</id>

<version>
0.6
</version>

<mod info>
Description
-----------
Adds Board Rules to your forum

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.

Files to edit
-------------
Admin/ManageBoards.pl 
Admin/ModList.pl 
Languages/English/Admin.lng
Languages/English/MessageIndex.lng
Sources/Load.pl
Sources/MessageIndex.pl
Sources/SubList.pl
Sources/System.pl
Templates/default/MessageIndex.template
Templates/yabb21/MessageIndex.template

Version History
---------------
V0.1 - First release - 19th October 2009
V0.2 - Fixed board setting issues and removed unwanted html - 20th October 2009
V0.3 - Removed unneeded edit from Load.pl - 25th October 2009
V0.4 - Updated for YaBB 2.5 - 6th September 2010
V0.5 - Added admin option to allow members to collapse board rules (Carsten) - 11th October 2010
V0.6 - Fixed quotes breaking rules description (Thanks Carsten!) - 8th December 2010
</mod info>

<author>
Derek Barnstorm and Carsten
</author>

<homepage>
http://www.boardmod.org / www.carsten-dalgaard.dk/cgi-bin/yabb2/YaBB.pl
</homepage>

<edit file>
Admin/ManageBoards.pl
</edit file>

<search for>
			$rbinch    = qq~ disabled="disabled"~;
			$rbinexist = 1;
		}
</search for>

<add after>

		### Board Rules Mod Start ###
		$en_rules = "";
		if (${$uid.$id}{'rules'} == 1) { $en_rules = qq~ checked="checked"~; }
		$en_rulescoll = "";
		if (${$uid.$id}{'rulescollapse'} == 1) { $en_rulescoll = qq~ checked="checked"~; }
		$rulestitle = ${$uid.$editboards[$i]}{'rulestitle'};
		&ToChars($rulestitle);
		$rulesdesc = ${$uid.$editboards[$i]}{'rulesdesc'};
		$rulesdesc =~ s~<br />~\n~g;
		&ToChars($rulesdesc);
		### Board Rules Mod End ###
</add after>

<search for>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" id="rbin$i" name="rbin$i" value="1" $rbinch onclick="javascript: if (this.checked) checkbin(true, '$i'); else checkbin(false, '$i');" /> <label for="rbin$i">$admin_txt{'64j'}</label></td>
  </tr><tr>
</search for>

<add after>
    <td class="catbg"  colspan="4"><b>$admin_txt{'rules'}:</b></td>
  </tr><tr>
    <td class="windowbg" width="25%" align="left"><label for="rules$i"><b>$admin_txt{'rules1'}:</b></label></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" name="rules$i" id="rules$i" value="1"$en_rules /></td>
  </tr><tr>
    <td class="windowbg" width="25%" align="left"><label for="rulescollapse$i"><b>$exptxt{'6'}</b></label></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" name="rulescollapse$i" id="rulescollapse$i" value="1"$en_rulescoll /></td>
  </tr><tr>
    <td class="windowbg"  width="25%" align="left"><label for="rulestitle$i"><b>$admin_txt{'rules2'}:</b></label></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="text" name="rulestitle$i" id="rulestitle$i" value="$rulestitle" size="50" maxlength="100" /></td>
  </tr><tr>
    <td class="windowbg" width="25%" align="left"><label for="rulesdesc$i"><b>$admin_txt{'rules3'}:</b><br /><span class="small">$admin_txt{'rules4'}</span></label></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><textarea name="rulesdesc$i" id="rulesdesc$i" rows="5" cols="30" style="width:98%; height:60px">$rulesdesc</textarea></td>
  </tr><tr>
</add after>

<search for>
		if ($FORM{"maxage$i"} && $FORM{"maxage$i"} < $FORM{"minage$i"}) { $FORM{"maxage$i"} = $FORM{"minage$i"}; }
</search for>

<add after>

		### Board Rules Mod Start ###
		if ($FORM{"rules$i"} eq '') { $FORM{"rules$i"} = 0; }
		if ($FORM{"rulescollapse$i"} eq '') { $FORM{"rulescollapse$i"} = 0; }
		$brulestitle = $FORM{"rulestitle$i"};
		&FromChars($brulestitle);
		$brulesdesc = $FORM{"rulesdesc$i"};
		&FromChars($brulesdesc);
		$brulesdesc =~ s/\r//g;
		$brulesdesc =~ s~\n~<br \/>~g;
		### Board Rules Mod End ###
</add after>

<search for>
		push(@boardcontrol, "$FORM{\"cat$i\"}|$id|$FORM{\"pic$i\"}|$bdescription|$FORM{\"moderators$i\"}|$FORM{\"moderatorgroups$i\"}|$FORM{\"topicperms$i\"}|$FORM{\"replyperms$i\"}|$FORM{\"pollperms$i\"}|$FORM{\"zero$i\"}|$FORM{\"membergroups$i\"}|$FORM{\"ann$i\"}|$FORM{\"rbin$i\"}|$FORM{\"att$i\"}|$FORM{\"minage$i\"}|$FORM{\"maxage$i\"}|$FORM{\"gender$i\"}\n");
</search for>

<replace>
		push(@boardcontrol, "$FORM{\"cat$i\"}|$id|$FORM{\"pic$i\"}|$bdescription|$FORM{\"moderators$i\"}|$FORM{\"moderatorgroups$i\"}|$FORM{\"topicperms$i\"}|$FORM{\"replyperms$i\"}|$FORM{\"pollperms$i\"}|$FORM{\"zero$i\"}|$FORM{\"membergroups$i\"}|$FORM{\"ann$i\"}|$FORM{\"rbin$i\"}|$FORM{\"att$i\"}|$FORM{\"minage$i\"}|$FORM{\"maxage$i\"}|$FORM{\"gender$i\"}|$FORM{\"rules$i\"}|$brulestitle|$brulesdesc|$FORM{\"rulescollapse$i\"}\n");
</replace>

<search for>
			my (undef, $oldboard,$pic,$bdescription,$moderators,$moderatorgroups,$topicperms,$replyperms,$pollperms,$zero,$membergroups,$ann,$rbin,$att,$minage,$maxage,$gender) = split(/\|/, $oldcontrols[$cnt]);
</search for>

<replace>
			my (undef, $oldboard,$pic,$bdescription,$moderators,$moderatorgroups,$topicperms,$replyperms,$pollperms,$zero,$membergroups,$ann,$rbin,$att,$minage,$maxage,$gender,$rules,$brulestitle,$brulesdesc,$rulescollapse) = split(/\|/, $oldcontrols[$cnt]);
</replace>

<search for>
				$oldcontrols[$cnt] = qq~$category|$moveitem|$pic|$bdescription|$moderators|$moderatorgroups|$topicperms|$replyperms|$pollperms|$zero|$membergroups|$ann|$rbin|$att|$minage|$maxage|$gender~;
</search for>

<replace>
				$oldcontrols[$cnt] = qq~$category|$moveitem|$pic|$bdescription|$moderators|$moderatorgroups|$topicperms|$replyperms|$pollperms|$zero|$membergroups|$ann|$rbin|$att|$minage|$maxage|$gender|$rules|$brulestitle|$brulesdesc|$rulescollapse~;
</replace>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$mod_boardrules = "Board Rules|Derek Barnstorm and Carsten|Adds Board Rules to your forum.|0.6|8th December 2010";
	push (@installed_mods, "$mod_boardrules");
	
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%floodtxt = (
</search for>

<add before>
### Board Rules Mod Start ###
'rules' => 'Board Rules',
'rules1' => 'Enable Board Rules',
'rules2' => 'Rules Title',
'rules3' => 'Rules',
'rules4' => 'You can use HTML here.',
### Board Rules Mod End ###
</add before>


<edit file>
Languages/English/MessageIndex.lng
</edit file>

<search for>
'845' => 'Moved Topic',
</search for>

<add after>
'collruletext' => 'Board Rules Collapsed',
</add after>

<edit file>
Sources/Load.pl
</edit file>

<search for>
		($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntmembergroups, $cntann, $cntrbin, $cntattperms, $cntminageperms, $cntmaxageperms, $cntgenderperms) = split(/\|/, $boardline);
</search for>

<replace>
		($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntmembergroups, $cntann, $cntrbin, $cntattperms, $cntminageperms, $cntmaxageperms, $cntgenderperms, $rules, $rulestitle, $rulesdesc, $rulescollapse) = split(/\|/, $boardline);
</replace>

<search for>
			'genderperms'  => $cntgenderperms,);
</search for>

<replace>
			'genderperms'  => $cntgenderperms,
			'rules'        => $rules,
			'rulestitle'   => $rulestitle,
			'rulesdesc'    => $rulesdesc,
            'rulescollapse' => $rulescollapse,);
</replace>

<search for>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms) = split(/\|/, $boardline);
</search for>

<replace>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms, $rules, $rulestitle, $rulesdesc, $rulescollapse) = split(/\|/, $boardline);
</replace>

<search for>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms\n");
</search for>

<replace>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms|$rules|$rulestitle|$rulesdesc|$rulescollapse\n");
</replace>

<search for>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms) = split(/\|/, $boardline);
</search for>

<replace>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms, $rules, $rulestitle, $rulesdesc, $rulescollapse) = split(/\|/, $boardline);
</replace>

<search for>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms\n");
</search for>

<replace>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms|$rules|$rulestitle|$rulesdesc|$rulescollapse\n");
</replace>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
	$messageindex_template =~ s/({|<)yabb colspan(}|>)/$colspan/g;
</search for>

<add after>

	### Board Rules Mod Start ###
	if (${$uid.$currentboard}{'rules'} == 1) {
		&ToChars(${$uid.$currentboard}{'rulestitle'});
		&ToChars(${$uid.$currentboard}{'rulesdesc'});
		$tmpruletxt = qq~${$uid.$currentboard}{'rulesdesc'}~;

		if (!$iamguest && ${$uid.$currentboard}{'rulescollapse'} == 1) {
			$tmprulelgt = length(${$uid.$currentboard}{'rulesdesc'});
			$rulestitle = qq~<img src="$imagesdir/cat_collapse.gif" id="bdrulecollapse" alt="$boardindex_exptxt{'2'}" title="$boardindex_exptxt{'2'}" border="0" style="cursor: pointer;" onclick="collapseBDrule($tmprulelgt);" />~;
			my @collbdrules = split(/\|/, ${$uid.$username}{'collapsebdrules'});
			for($i = 0; $i < @collbdrules; $i++) {
				($rulebd, $rulelgt) = split(/,/, $collbdrules[$i]);
				if($rulebd eq $currentboard && $rulelgt == $tmprulelgt) {
					$tmpruletxt = qq~$messageindex_txt{'collruletext'}~;
					$rulestitle = qq~<img src="$imagesdir/cat_expand.gif" id="bdrulecollapse" alt="$boardindex_exptxt{'1'}" title="$boardindex_exptxt{'1'}" border="0" style="cursor: pointer;" onclick="collapseBDrule($tmprulelgt);" />~;
				}
			}
		}

		$rulestitle .= qq~&nbsp;${$uid.$currentboard}{'rulestitle'}~;
		$rulesdesc = qq~<div id="bdruledesc">$tmpruletxt</div>~;

		if (!$iamguest && ${$uid.$currentboard}{'rulescollapse'} == 1) {
			$rulesdesc .= qq~
			<textarea id="actruletxt" name="actruletxt" rows="1" cols="1" style="display: none;">${$uid.$currentboard}{'rulesdesc'}</textarea>
			<input type="hidden" id="tmpruletxt" value="$messageindex_txt{'collruletext'}" />
			<script language="JavaScript1.2" type="text/javascript">
			<!--
			function collapseBDrule(rulelgt) {
				var tmpruletxt = document.getElementById('tmpruletxt').value;
				var actruletxt = document.getElementById('actruletxt').value;
				if (document.getElementById("bdruledesc").innerHTML == tmpruletxt) linkdesclg = 1;
				else linkdesclg = rulelgt;
				var thisboard = "$currentboard";
				var doexpand = "$boardindex_exptxt{'1'}";
				var docollaps = "$boardindex_exptxt{'2'}";
				if (document.getElementById("bdruledesc").innerHTML == tmpruletxt) {
					document.getElementById("bdruledesc").innerHTML = actruletxt;
					document.getElementById('bdrulecollapse').src = "$imagesdir/cat_collapse.gif";
					document.getElementById('bdrulecollapse').alt = docollaps;
					document.getElementById('bdrulecollapse').title = docollaps;
				}
				else {
					document.getElementById("bdruledesc").innerHTML = tmpruletxt;
					document.getElementById('bdrulecollapse').src="$imagesdir/cat_expand.gif";
					document.getElementById('bdrulecollapse').alt = doexpand;
					document.getElementById('bdrulecollapse').title = doexpand;
				}
				var url = '$scripturl?action=bdrulecoll&rulebd=' + thisboard + '&rulelg=' + linkdesclg;
				GetXmlHttpObject();
				if (xmlHttp == null) return;
				xmlHttp.open("GET",url,true);
				xmlHttp.send(null);
			}
			-->
			</script>
			~;
		}

		$messageindex_template =~ s/({|<)yabb rulestitle(}|>)/$rulestitle/g;
		$messageindex_template =~ s/({|<)yabb rulesdescription(}|>)/$rulesdesc/g;
	}
	### Board Rules Mod End ###
</add after>

<search for>
sub MarkRead { # Mark all threads in this board as read.
</search for>

<add before>
sub collapse_bdrule {
	$tmpboardrules = "";
	my @tmpbdrule = split(/\|/, ${$uid.$username}{'collapsebdrules'});
	for($i = 0; $i < @tmpbdrule; $i++) {
		my ($tmrulebd, $tmrulelgt) = split(/,/, $tmpbdrule[$i]);
		if($tmrulebd ne $INFO{'rulebd'}) {
			$tmpboardrules .= qq~$tmpbdrule[$i]|~;
		}
	}
	if($INFO{'rulelg'} > 1) { $tmpboardrules .= qq~$INFO{'rulebd'},$INFO{'rulelg'}~; }
	$tmpboardrules =~ s/\|\Z//;
	${$uid.$username}{'collapsebdrules'} = $tmpboardrules;
	&UserAccount($username, "update");
}

</add before>


<edit file>
Sources/SubList.pl
</edit file>

<search for>
'addtab2',"AdvancedTabs.pl&AddNewTab2",
</search for>

<add after>
'bdrulecoll',"MessageIndex.pl&collapse_bdrule",
</add after>


<edit file>
Sources/System.pl
</edit file>

<search for>
	if ($extendedprofiles) {
		require "$sourcedir/ExtendedProfiles.pl";
		push(@tags, &ext_get_fields_array());
	}
</search for>

<add after>
	push(@tags, "collapsebdrules");
</add after>


<edit file>
Templates/default/MessageIndex.template
</edit file>

<search for>
<!-- Board Description end -->


~;
}
</search for>

<add after>

if (${$uid.$currentboard}{'rules'} == 1) {
$messageindex_template .= qq~

<!-- Board Rules start -->

<table cellpadding="3" cellspacing="1" border="0" width="100%" class="bordercolor">
<tr>
    <td class="titlebg" height="18" align="left">{yabb rulestitle}</td>
</tr>
<tr>
    <td class="windowbg" align="left">{yabb rulesdescription}</td>
</tr>
</table>
<br />

<!-- Board Rules end -->

~;
}

</add after>

<edit file>
Templates/yabb21/MessageIndex.template
</edit file>

<search for>
	<yabb description>
	<br /><br /></td>
</tr>
</table>
</div>~;
}
</search for>

<add after>

if (${$uid.$currentboard}{'rules'} == 1) {
$messageindex_template .= qq~

<!-- Board Rules start -->

<br />
<table cellpadding="3" cellspacing="1" border="0" width="100%" class="bordercolor">
<tr>
    <td class="titlebg" height="18" align="left"><yabb rulestitle></td>
</tr>
<tr>
    <td class="windowbg" align="left"><yabb rulesdescription></td>
</tr>
</table>
<br />

<!-- Board Rules end -->

~;
}

</add after>